//
// test_source.hh : Test Source Include File
// author         : Fabio Silva
//
// Copyright (C) 2000-2003 by the University of Southern California
// $Id: test_source.hh,v 1.1 2005/04/22 06:08:36 fstann Exp $
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License,
// version 2, as published by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along
// with this program; if not, write to the Free Software Foundation, Inc.,
// 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
//
//

#ifndef _TEST_SOURCE_HH_
#define _TEST_SOURCE_HH_

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif // HAVE_CONFIG_H

#include "test_common.hh"

class TestSourceApp;

class TestSourceApp : public DiffApp {
public:
  TestSourceApp(int argc, char **argv);

  virtual ~TestSourceApp()
  {
    // Nothing to do
  };

  void recv(NRAttrVec *data, NR::handle my_handle);
  void run();
  void stop();

private:
  // NR Specific variables
  handle pubHandle_;

  // Test Source App variables
  struct timeval start_time_;
  int num_msg_sent_;
  int my_id_;
  bool using_push_;
  bool using_gear_;
  float send_rate_lambda_;
  float lat_min_;
  float lat_max_;
  float long_min_;
  float long_max_;
  float lat_pt_;
  float long_pt_;

  NRAttrVec data_attr_;
  NRSimpleAttribute<void *> *timeAttr_;
  NRSimpleAttribute<int> *counterAttr_;
  EventTime *lastEventTime_;

  handle setupPublication();
  void parseCommandLine(int argc, char **argv);
  void usage(char *s);
};

#endif // !_TEST_SOURCE_HH_
